<?php
/*
Plugin Name: WPContaxe
Plugin URI: http://www.contaxe.com
Description: Contaxe-Werbemittel in Ihren Wordpress-Blog einbinden.
Version: 1.1.1
Author: Contaxe
Author URI: http://www.contaxe.com
*/

/*
 * rule system greatly inspired by whoseesads from Ozh
 * http://planetozh.com/blog/my-projects/wordpress-plugin-who-sees-ads-control-adsense-display/
 * released under GPLv2
 */

require_once(dirname(__FILE__) . '/defines.php');

if (!class_exists('WPContaxe')) {

class WPContaxe {
	var $adminOptionsName	= 'wpcontaxe';
	var $options			= NULL;
	var $numWidgets			= 3;
	var $cntBanners			= 0;

	function activatePlugin() {
		$this->getAdminOptions();
	}

	function getAdminOptions() {
		if (isset($this->options)) return $this->options;

		$admin_options = array(
			'global_channel'		=> '',
			'global_adminssee'		=> 'demo',		// current_user_can('manage_options')
			'global_userssee'		=> 'ads',		// is_user_logged_in
			'global_visitorssee'	=> 'ads',		// else ...
			'global_regularvisits'	=> '3',			// regular visitor has X visits...
			'global_regulardays'	=> '10',		// ...in the last Y days.
			'highlighter_enabled'	=> false,
			'highlighter_channel'	=> '',			// c
			'highlighter_style'		=> '',			// s
			'highlighter_words'		=> 5,			// hw	1-10
			'highlighter_repeat'	=> 5,			// wr	1-100
			'highlighter_delay'		=> 2000,		// pct	500-4000
			'highlighter_charset'	=> 0,			// cs
			'highlighter_bigfont'	=> false,		// t=20 - small; t=54 - big
			'highlighter_rules'		=> array(),
			'ias_enabled'			=> false,
			'ias_channel'			=> '',			// c
			'ias_style'				=> '',			// s
			'ias_type'				=> 57,			// t=55 - 1 ad; t=56 - 2 ads; t=57 - 5 titles; t=58 - 10 titles
			'widgets'				=> array(),		// sidebar widgets
			'banners'				=> array(),		// banners
			'positions'				=> array(),		// positions
		);
		$options = get_option($this->adminOptionsName);
		if (!empty($options)) {
			foreach ($options as $key => $option) $admin_options[$key] = $option;
		}
		for ($i = 1; $i <= $this->numWidgets; $i++) {
			if (!isset($admin_options['widgets'][$i])) {
				$admin_options['widgets'][$i] = array(
					'title'		=> 'Anzeige',
					'banner'	=> NULL
				);
			}
		}
		update_option($this->adminOptionsName, $admin_options);
		$this->options = $admin_options;
		return $this->options;
	}

	function registerAdminMenu() {
		global $plugin_page;
		if (is_plugin_page() && strpos($plugin_page, 'wpcontaxe') !== false) {
			wp_enqueue_script('scriptaculous');
		}
		add_menu_page('Contaxe-Werbung', 'Contaxe-Werbung', 9, __FILE__, array(&$this, 'adminGeneralSettings'));
		add_submenu_page(__FILE__, 'Allgemein', 'Allgemein', 9, __FILE__, array(&$this, 'adminGeneralSettings'));
		add_submenu_page(__FILE__, 'Highlighter', 'Highlighter', 9, 'wpcontaxe/admin/highlighter.php');
		add_submenu_page(__FILE__, 'Intelligent Search Ad', 'Intelligent Search Ad', 9, 'wpcontaxe/admin/ias.php');
		add_submenu_page(__FILE__, 'Banner', 'Banner', 9, 'wpcontaxe/admin/banner.php');
		add_submenu_page(__FILE__, 'Banner positionieren', 'Banner positionieren', 9, 'wpcontaxe/admin/positions.php');
	}

	function printAdminCSS() {
		global $plugin_page;
		if (!is_plugin_page() || strpos($plugin_page, 'wpcontaxe') === false) return;
		$GLOBALS['WPCONTAXE_HELP_IMAGE'] = get_bloginfo('url') . '/wp-content/plugins/' . dirname(plugin_basename(__FILE__)) . '/images/help.gif';
?>
<style type="text/css">
.wpcontaxe_sortable {
	border:2px solid #ddf;
	margin:0;
	padding:5px;
}
.wpcontaxe_sortable:hover {
	border: 2px solid #aae;
}
.wpcontaxe_sortable_1 {
	list-style-type:none;
}
.wpcontaxe_sortable_2 {
	list-style-type:decimal !important;
	list-style-type:none;
}
.wpcontaxe_sortable li tt {
	color:#99c;
}
.wpcontaxe_sortable li {
	border:1px solid #eed;
	padding:2px 10px;
	background:#eef;
	white-space:nowrap;
}
.wpcontaxe_handle {
	color: #aaaaee;
	font-size: 16px;
	font-weight: bolder;
	cursor: move;
}
.wpcontaxe_helpbox {
	position:absolute;
	right:50px;
	margin:15 5%;
	z-index:9999;
	font-size:11px;
	width:306px;
	padding:2px 10px 10px 20px;
	border:2px solid #ff3;
	background:#ffc;
}
.wpcontaxe_helpbox h3 {
	font-size: 120%;
}
.wpcontaxe_helpicon {
	cursor: pointer;
}
</style>
<?
	}

	function printAdminJS() {
		global $plugin_page;
		if (!is_plugin_page() || strpos($plugin_page, 'wpcontaxe') === false) return;
?>
<script type="text/javascript">
// <![CDATA[
	// Help display function
	function wpcontaxe_togglehelp(item,target) {
		if(!$(item)) return;
		$(item).onmouseover=function(e) {
			// for MSIE: get event, and hide <select> elements
			if (!e) {
				var e = window.event; 
				wpcontaxe_toggleselect('hide',target);
			}
			Effect.Appear($(target),{duration:0.2});
			$(target).style.top = (Event.pointerY(e)+20)+'px';
			//$(target).style.left = (Event.pointerX(e)+20)+'px';
		};
		$(item).onmouseout=function(e){
			if (!e) wpcontaxe_toggleselect('show');
			Effect.Fade($(target),{duration:0.1});
		};
	}
	
	// Toggle visibility of <select> elements (for MSIE, grrr)
	var wpcontaxe_visibledrops = new Array();
	function wpcontaxe_toggleselect(action,helpdiv) {
		if (action == 'hide') {
			document.getElementsByClassName('wpcontaxe_select').each(function(item){
				// if element is visible (ie inside a visible <ul>) hide it and add it to our list
				wpcontaxe_visibledrops[wpcontaxe_visibledrops.length] = item;
				$(item).style.visibility = 'hidden';
			});
		} else {
			// show every item in our list
			wpcontaxe_visibledrops.each(function(item){
				$(item).style.visibility = 'visible';
			});
			// all elements now back to visible, empty our list
			wpcontaxe_visibledrops = new Array();
		}
	}
	// Help stuff init
	['channel','design','words','repeat','delay','params','name','active','possible'].each(function(item){
		wpcontaxe_togglehelp('helpicon_'+item,'helpbox_'+item);
	});

// ]]>
</script>
<?
	}

	function adminGeneralSettings() {
		$options = $this->getAdminOptions();
		if (isset($_POST['updateGeneralSettings'])) {
			check_admin_referer('wpcontaxe-update-general');
			$options['global_channel']		= $_POST['channel'];
			$options['global_adminssee']	= $_POST['adminssee'];
			$options['global_userssee']		= $_POST['userssee'];
			$options['global_visitorssee']	= $_POST['visitorssee'];
			$options['global_regularvisits']= $_POST['regularvisits'];
			$options['global_regulardays']	= $_POST['regulardays'];
			update_option($this->adminOptionsName, $options);
			$this->options = $options;
?>
<div id="contaxe-notice" class="updated fade-00ff00"><p>Einstellungen gespeichert.</p></div>
<?php
		}
		include(dirname(__FILE__) . '/admin/general-settings-form.php');
	}

	function adminHighlighter() {
		$options = $this->getAdminOptions();
		if (isset($_POST['updateHighlighterSettings'])) {
			check_admin_referer('wpcontaxe-update-highlighter');
			$options['highlighter_enabled']	= $_POST['enabled'] == 'true';
			$options['highlighter_channel']	= $_POST['channel'];
			$options['highlighter_style']	= $_POST['style'];
			$options['highlighter_bigfont']	= $_POST['bigfont'] == 'true';
			$options['highlighter_rules']	= $this->parseRules();
			if (is_numeric($_POST['words']))	$options['highlighter_words']	= min(10,   max(1,   $_POST['words'] ));
			if (is_numeric($_POST['repeat']))	$options['highlighter_repeat']	= min(100,  max(1,   $_POST['repeat']));
			if (is_numeric($_POST['delay']))	$options['highlighter_delay']	= min(4000, max(500, $_POST['delay'] ));
			update_option($this->adminOptionsName, $options);
			$this->options = $options;
?>
<div id="contaxe-notice" class="updated fade-00ff00"><p>Einstellungen gespeichert.</p></div>
<?php
		}
		include(dirname(__FILE__) . '/admin/highlighter-settings-form.php');
	}

	function adminIAS() {
		$options = $this->getAdminOptions();
		if (isset($_POST['updateIASSettings'])) {
			check_admin_referer('wpcontaxe-update-ias');
			$options['ias_enabled']	= $_POST['enabled'] == 'true';
			$options['ias_channel']	= $_POST['channel'];
			$options['ias_style']	= $_POST['style'];
			$options['ias_type']	= $_POST['type'];
			update_option($this->adminOptionsName, $options);
			$this->options = $options;
?>
<div id="contaxe-notice" class="updated fade-00ff00"><p>Einstellungen gespeichert.</p></div>
<?php
		}
		include(dirname(__FILE__) . '/admin/ias-settings-form.php');
	}

	function adminPositions() {
		$options = $this->getAdminOptions();
		if (isset($_POST['updatePositions'])) {
			check_admin_referer('wpcontaxe-update-positions');
			foreach ($_POST['banner'] as $key => $value) {
				if (empty($value)) {
					unset($options['positions'][$key]);
					continue;
				}
				$options['positions'][$key] = array(
					'banner'	=> $value,
					'position'	=> isset($_POST['position'][$key]) ? $_POST['position'][$key] : 1
				);
			}
			update_option($this->adminOptionsName, $options);
			$this->options = $options;
?>
<div id="contaxe-notice" class="updated fade-00ff00"><p>Einstellungen gespeichert.</p></div>
<?php
		}
		include(dirname(__FILE__) . '/admin/positions-form.php');
	}

	function adminBanner() {
		$options = $this->getAdminOptions();
		if (!isset($_REQUEST['action'])) {
			include(dirname(__FILE__) . '/admin/list-banners.php');
			return;
		}
		switch ($_REQUEST['action']) {
			case 'add':
				if ($this->addBanner()) break;
				include(dirname(__FILE__) . '/admin/edit-banner.php');
				return;
			case 'edit':
//				if ($this->editBanner()) break;
				$this->editBanner();
				include(dirname(__FILE__) . '/admin/edit-banner.php');
				return;
			case 'delete':
				$this->deleteBanner();
				break;
			default:
				echo 'Unbekannte Aktion.';
				return;
		}
		$options = $this->getAdminOptions();
		include(dirname(__FILE__) . '/admin/list-banners.php');
	}

	function addBanner() {
		$options = $this->getAdminOptions();
		if (!isset($_POST['action'])) return false;
		check_admin_referer('wpcontaxe-add_');

//		if (!isset($GLOBALS['WPCONTAXE_ADFORMATS'][$_POST['format']])) {
//			$msg	.= '<li>Bitte wählen Sie ein Format.</li>';
//		}
		end($options['banners']);
		$id = key($options['banners']) + 1;
		$options['banners'][$id]	= array(
			'id'		=> $id,
			'name'		=> empty($_POST['name']) ? 'Unbenannt ' . $id: $_POST['name'],
			'channel'	=> $_POST['channel'],
			'format'	=> $_POST['format'],
			'opt'		=> $_POST['opt'],
			'rnd'		=> isset($_POST['rnd']),
			'params'	=> $_POST['params'],
			'enabled'	=> $_POST['enabled'] == 'true',
			'style'		=> $_POST['style'],
			'rules'		=> $this->parseRules(),
			'created'	=> current_time('mysql', 1),
			'modified'	=> current_time('mysql', 1),
		);
		update_option($this->adminOptionsName, $options);
		$this->options = $options;
		return true;
	}

	function editBanner() {
		$options = $this->getAdminOptions();
		if (!isset($_POST['action'])) return false;
		check_admin_referer('wpcontaxe-edit_' . $_POST['id']);
/*
		if (!isset($GLOBALS['WPCONTAXE_ADFORMATS'][$_POST['format']])) {
			$msg	.= '<li>Bitte wählen Sie ein Format.</li>';
		}
*/
		$id = $_POST['id'];
		$options['banners'][$id]['id']			= $id;
		$options['banners'][$id]['name']		= empty($_POST['name']) ? 'Unbenannt ' . $id: $_POST['name'];
		$options['banners'][$id]['channel']		= $_POST['channel'];
		$options['banners'][$id]['format']		= $_POST['format'];
		$options['banners'][$id]['opt']			= $_POST['opt'];
		$options['banners'][$id]['rnd']			= isset($_POST['rnd']);
		$options['banners'][$id]['params']		= $_POST['params'];
		$options['banners'][$id]['enabled']		= isset($_POST['enabled']);
		$options['banners'][$id]['modified']	= current_time('mysql', 1);
		$options['banners'][$id]['enabled']		= $_POST['enabled'] == 'true';
		$options['banners'][$id]['style']		= $_POST['style'];
		$options['banners'][$id]['rules']		= $this->parseRules();
		update_option($this->adminOptionsName, $options);
		$this->options = $options;
?>
<div id="contaxe-notice" class="updated fade-00ff00"><p>Banner gespeichert.</p></div>
<?php
		return true;
	}

	function deleteBanner() {
		$options = $this->getAdminOptions();
		if (!isset($_GET['action'])) return false;
		check_admin_referer('wpcontaxe-delete_' . $_GET['id']);
		$id = $_GET['id'];
		unset($options['banners'][$id]);
		update_option($this->adminOptionsName, $options);
		$this->options = $options;
		return true;
	}

	function parseRules() {
		if (empty($_POST['serialized'])) return array();
		parse_str($_POST['serialized'], $rules);
		$rules = array_shift($rules);

		$ret = array();
		foreach ($rules as $rule) {
			if ($rule != 'fallback' && !isset($_POST['rule_' . $rule . '_display'])) continue;
			$rule_info = array(
				'type'		=> $rule,
				'params'	=> NULL,
				'display'	=> ($_POST['rule_' . $rule . '_display'] == 1) 
			);
			switch ($rule) {
				case 'date'		:
						$date_before= isset($_POST['rule_date_before'])	? strtotime($_POST['rule_date_before']) : 0;
						$date_after	= isset($_POST['rule_date_after'])	? strtotime($_POST['rule_date_after'])	: 0;
						if ($date_before	== 0) $date_before	= mktime(0, 0, 0, date('n'), date('j'), date('Y'));
						if ($date_after		== 0) $date_after	= mktime(0, 0, 0, date('n') + 1, date('j'), date('Y'));
						$rule_info['params']				= array();
						$rule_info['params']['before']		= $date_before;
						$rule_info['params']['after']		= $date_after;

					break;
				case 'fallback'	:
						$rule_info['params']	= isset($_POST['rule_fallback'])	? $_POST['rule_fallback'] : '';
					break;
				case 'olderthan':
						$age					= isset($_POST['rule_olderthan'])	? (int) $_POST['rule_olderthan'] : 0;
						if ($age <= 0) $age		= 3;
						$rule_info['params']	= $age;
					break;
			}
			$ret[] = $rule_info;
		}
		return $ret;
	}

	function getMode($options) {
		switch (true) {
			case is_preview():							return 'demo';							break;
			case current_user_can('manage_options'):	return $options['global_adminssee'];	break;
			case is_user_logged_in():					return $options['global_userssee'];		break;
			default:									return $options['global_visitorssee'];	break;
		}
	}

	function checkRules($id) {
		$options = $this->getAdminOptions();
		if (empty($options['banners'][$id]['rules'])) return true;
		foreach ($options['banners'][$id]['rules'] as $rule) {
			if ($rule['type'] == 'fallback') {
				$code = $this->getBannerURL($rule['params']);
				if (!empty($code)) return $code;
				continue;
			}
			if ($this->testRule($rule['type'], $rule['params'])) {
				return $rule['display'];
			}
		}
		return false;
	}

	function checkHighlighterRules($multiple) {
		$options = $this->getAdminOptions();
		if (empty($options['highlighter_rules'])) return true;
		foreach ($options['highlighter_rules'] as $rule) {
			if ($rule['type'] == 'fallback') continue;
			if ($multiple) {
				switch ($rule['type']) {
					case 'olderthan': return true;
				}
			}
			if ($this->testRule($rule['type'], $rule['params'], $multiple)) {
				return $rule['display'];
			}
		}
		return false;
	}

	function ruleFromSearchEngine() {
		$search_engines = array('/search?', 'images.google.', 'web.info.com', 'search.', 'del.icio.us/search', 'soso.com', '/search/', '.yahoo.');
		foreach ($search_engines as $url) {
			if (strpos($_SERVER['HTTP_REFERER'], $url) !== false) return true;
		}
		return false;	
	}

	function ruleRegularVisitor() {
		$options = $this->getAdminOptions();
		return ($this->cntVisits >= $options['global_regularvisits']) && ((time() - $this->lastVisit) <= (86400 * $options['global_regulardays']));
	}

	function ruleDate($date) {
		$now = time();
		return ($now > $date['before'] && $now < ($date['after'] + (24 * 60 * 60)));
	}

	function ruleOlderThan($limit) {
		$age = floor( (time() - get_the_time('U')) / (24 * 60 * 60));
		return ($age > $limit);
	}

	function testRule($rule, $params) {
		switch ($rule) {
			case 'any'				: return true;
			case 'date'				: return $this->ruleDate($params);
//			case 'fallback'			: XXX not handled at this point
			case 'fromsearchengine'	: return $this->ruleFromSearchEngine();
			case 'home'				: return is_home();
			case 'loggedin'			: return is_user_logged_in();
			case 'olderthan'		: return $this->ruleOlderThan($params);
			case 'regularvisitor'	: return $this->ruleRegularVisitor();
			default					: break;
		}
		return false;
	}

	function printSortable($id, $active) {
		$options	= $this->getAdminOptions();
		echo '<ul id="rules_' . ($active ? 2 : 1) . '" class="wpcontaxe_sortable wpcontaxe_sortable_1">';
		if (!$active) {
			foreach ($GLOBALS['WPCONTAXE_RULES'] as $rule) {
				if ($this->bannerHasRule($id, $rule)) continue;
				if ($id == 'highlighter' && $rule == 'fallback') continue; 
				echo $this->printSortableItem($id, $rule);
			}
		}
		else if (isset($options['banners'][$id]) && !empty($options['banners'][$id]['rules'])) {
			foreach ($options['banners'][$id]['rules'] as $rule_info) {
				echo $this->printSortableItem($id, $rule_info['type'], $rule_info['display'], $rule_info['params']);
			}
		}
		else if ($id == 'highlighter') {
			foreach ($options['highlighter_rules'] as $rule_info) {
				if ($rule_info['type'] == 'fallback') continue; 
				echo $this->printSortableItem($id, $rule_info['type'], $rule_info['display'], $rule_info['params']);
			}
		}
		echo '</ul>';
		
	}

	function bannerHasRule($id, $rule) {
		$options	= $this->getAdminOptions();
		if ($id == 'highlighter') {
			if (empty($options['highlighter_rules'])) return false;
			foreach ($options['highlighter_rules'] as $rule_info) {
				if ($rule_info['type'] == $rule) return true;
			}
			return false;
		}
		if (!isset($options['banners'][$id])) return false;
		if (empty($options['banners'][$id]['rules'])) return false;
		foreach ($options['banners'][$id]['rules'] as $rule_info) {
			if ($rule_info['type'] == $rule) return true;
		}
		return false;
	}

	function printSortableItem($id, $rule, $display = true, $params = NULL) {
		$options	= $this->getAdminOptions();
		$text		= '';
		$select = '
<select name="rule_' . $rule . '_display" id="rule_' . $rule . '_display" class="wpcontaxe_select">
		<option value="1"' . ($display	? ' selected="selected"': '') . '>anzeigen</option>
		<option value="0"' . (!$display	? ' selected="selected"': '') . '>nicht anzeigen</option>
</select>.';
		switch ($rule) {
			case 'any'				:
				$text	= '<tt>(Sonst) Immer</tt> ' . $select;
				break;
			case 'date'				:
				$before	= !empty($params['before'])	? $params['before']	: mktime(0, 0, 0, date('n'), date('j'), date('Y'));
				$after	= !empty($params['after'])	? $params['after']	: mktime(0, 0, 0, date('n') + 1, date('j'), date('Y'));
				$after	= strftime('%Y-%m-%d', $after);
				$before	= strftime('%Y-%m-%d', $before);
				$text	= '<tt>Wenn</tt> das Datum zwischen <input type="text" name="rule_' . $rule . '_before" value="' . attribute_escape($before) . '"  size="10" /> und <input type="text" name="rule_' . $rule . '_after" value="' . attribute_escape($after) . '" size="10" /> liegt, <tt>dann</tt>' . $select;
				break;
			case 'home'	:
				$text	= '<tt>Wenn</tt> die aktuelle Seite die Startseite ist, <tt>dann</tt>' . $select;
				break;
			case 'loggedin'			: 
				$text	= '<tt>Wenn</tt> der Benutzer eingeloggt ist, <tt>dann</tt>' . $select;
				break;
			case 'fallback'			:
				if (empty($id) || count($options['banners']) >= 2) {
					$list	= '<select name="rule_' . $rule . '" class="wpcontaxe_select">';
					foreach ($options['banners'] as $banner) {
						if ($banner['id'] == $id) continue;
						$list .= '<option value="' . attribute_escape($banner['id']) . '"' . ($params == $banner['id'] ? ' selected="selected"': '') . '>' . $banner['name'] . '</option>';
					}
					$list  .= '</select>';
				}
				else {
					$list = 'einen anderen Banner (noch keiner vorhanden)';
				}
				$text	= '<tt>Wenn</tt> die vorherigen Bedingungen fehlschlagen, <tt>dann</tt> versuche ' . $list . ' anzuzeigen.';
				break;
			case 'fromsearchengine'	: 
				$text	= '<tt>Wenn</tt> der Besucher von einer Suchmaschine kommt, <tt>dann</tt>' . $select;
				break;
			case 'regularvisitor'	:
				$text	= '<tt>Wenn</tt> der Besucher ein regelm&auml;&szlig;iger Leser ist, <tt>dann</tt>' . $select;
				break;
			case 'olderthan'		:
				$age	= (int) $params;
				if ($age <= 0) $age = 3;
				$text	= '<tt>Wenn</tt> der Beitrag &auml;lter als <input type="text" name="rule_' . $rule . '" value="' . $age . '" size="3"/> Tage ist, <tt>dann</tt>' . $select;
				break;
			default					: break;
		}
		return '<li id="rule_' . $rule . '"><span class="wpcontaxe_handle">&times;</span> ' . $text . '</li>';
	}

	function getBannerURL($id, $demo = false) {
		$options = $this->getAdminOptions();
		if (!$demo && ($mode = $this->getMode($options)) == 'nothing') return '';
		if ($demo) $mode = 'demo';

		if (!$demo && (!isset($options['banners'][$id]) || !$options['banners'][$id]['enabled'])) return '';

		$channel = $options['banners'][$id]['channel'];
		if (empty($channel)) $channel = $options['global_channel'];
		if (empty($channel)) return '';

		if (!$demo)	{
			$ret = $this->checkRules($id);
			if ($ret === FALSE) return '';
			if ($ret !== TRUE) return $ret;
		}

		$url = 'http://www.contaxe.com/go/go.js?t=';
		$url.= $options['banners'][$id]['format'];
		$url.= '&c='	. urlencode($channel);
		$url.= '&opt='	. $options['banners'][$id]['opt'];

		if (!empty($options['banners'][$id]['style']))	$url.= '&s='	. $options['banners'][$id]['style'];
		if ($options['banners'][$id]['rnd'])			$url.= '&rnd=1';
		if ($mode == 'demo')							$url.= '&demo=1';

		$url.= $options['banners'][$id]['params'];
		return $url;
	}
	
	function getAdCode($url, $counts = true) {
		if (is_feed() || is_trackback() || is_404()) return '';
		if ($url == '') return '';
		if ($counts) {
			if ($this->cntBanners > 5) return '';
			$this->cntBanners++;
		}
		return '<script language="JavaScript1.1" type="text/javascript" src="' . wp_specialchars($url) . '"></script>';
	}

	function showBanner($id) {
		$options = $this->getAdminOptions();
		if (!isset($options['banners'][$id])) {
			foreach ($options['banners'] as $banner) {
				if ($banner['name'] == $id) {
					$id = $banner['id'];
					break;
				}
			}
		}
		if (!isset($options['banners'][$id])) {
			echo '<!--wpcontaxe: could not find banner-->';
			return;
		}
		$url = $this->getBannerURL($id);
		echo $this->getAdCode($url);
		
	}

	function showDemoBanner($id) {
		$url = $this->getBannerURL($id, true);
		echo $this->getAdCode($url, false);
	}


	function addHighlighter() {
		$options = $this->getAdminOptions();
		if (!$options['highlighter_enabled']) return;
		if (($mode = $this->getMode($options)) == 'nothing') return;

		$channel = $options['highlighter_channel'];
		if (empty($channel)) $channel = $options['global_channel'];
		if (empty($channel)) return;
	
		if (!$this->checkHighlighterRules(!(is_single() || is_page()))) return;

		$url = 'http://www.contaxe.com/go/go.js?t=';
		$url.= ($options['highlighter_bigfont'] ? '54' : '20');
		$url.= '&c='	. urlencode($channel);
		$url.= '&hw='	. urlencode($options['highlighter_words']);
		$url.= '&wr='	. urlencode($options['highlighter_repeat']);
		$url.= '&pct='	. urlencode($options['highlighter_delay']);
		if (!empty($options['highlighter_style']))	$url.= '&s=' . $options['highlighter_style'];
		if ($mode == 'demo') $url.= '&demo=1';
		echo $this->getAdCode($url, false);
	}

	function showDemoHighlighter() {
		$options = $this->getAdminOptions();
		$channel = $options['highlighter_channel'];
		if (empty($channel)) $channel = $options['global_channel'];
		if (empty($channel)) return;
	
		$url = 'http://www.contaxe.com/go/go.js?t=';
		$url.= ($options['highlighter_bigfont'] ? '54' : '20');
		$url.= '&c='	. urlencode($channel);
		$url.= '&hw='	. urlencode($options['highlighter_words']);
		$url.= '&wr='	. urlencode($options['highlighter_repeat']);
		$url.= '&pct='	. urlencode($options['highlighter_delay']);
		$url.= '&demo=1&kws=10356';
		if (!empty($options['highlighter_style']))	$url.= '&s=' . $options['highlighter_style'];
		echo $this->getAdCode($url, false);
	}
	
	function addIAS() {
		$options = $this->getAdminOptions();
		if (!$options['ias_enabled']) return;
		if (($mode = $this->getMode($options)) == 'nothing') return;

		$channel = $options['ias_channel'];
		if (empty($channel)) $channel = $options['global_channel'];
		if (empty($channel)) return;
	
		$url = 'http://www.contaxe.com/go/go.js?t=';
		$url.= $options['ias_type'];
		$url.= '&c=' . urlencode($channel);
		if (!empty($options['ias_style']))	$url.= '&s=' . $options['ias_style'];
		if ($mode == 'demo') $url.= '&demo=1';
		echo $this->getAdCode($url, false);
?>
<script language="JavaScript1.1" type="text/javascript">
    ContaxeSTHandlerInst.AddId('s');
</script>
<?php
	}

	function showDemoIAS() {
		$options = $this->getAdminOptions();
		$channel = $options['ias_channel'];
		if (empty($channel)) $channel = $options['global_channel'];
		if (empty($channel)) return;
	
		$url = 'http://www.contaxe.com/go/go.js?t=';
		$url.= $options['ias_type'];
		$url.= '&c=' . urlencode($channel);
		$url.= '&demo=1';
		if (!empty($options['ias_style']))	$url.= '&s=' . $options['ias_style'];
		echo $this->getAdCode($url, false);
	}

	/*
	 * parts of the following code are borrowed from AdSense Manager 
	 * http://wordpress.org/extend/plugins/adsense-manager/
	 * by Martin Fitzpatrick (http://www.mutube.com/)
	 * released under GPLv2
	 */
	function addEditorButton() {
		$options = $this->getAdminOptions();
		if (
			!strpos($_SERVER['REQUEST_URI'], 'post.php')
		&&	!strpos($_SERVER['REQUEST_URI'], 'post-new.php')
		&&	!strpos($_SERVER['REQUEST_URI'], 'page.php')
		&&	!strpos($_SERVER['REQUEST_URI'], 'page-new.php')
		&&	!strpos($_SERVER['REQUEST_URI'], 'bookmarklet.php')
		) return;
?>
<script language="JavaScript" type="text/javascript">
<!--
var ed_contaxe = document.createElement("select");
	
ed_contaxe.setAttribute("onchange", "add_contaxe(this)");

ed_contaxe.setAttribute("class", "ed_button");
ed_contaxe.setAttribute("title", "Contaxe-Werbung einfügen");
ed_contaxe.setAttribute("id", "ed_contaxe");					

opt_contaxe = document.createElement("option");
opt_contaxe.value='';
opt_contaxe.innerHTML='Contaxe...';
opt_contaxe.style.fontWeight='bold';
ed_contaxe.appendChild(opt_contaxe);

<?php
		$other_options = array(
			'no_banners'	=> '    Keine Banner einfügen',
			'no_hl'			=> '    Highlighter deaktivieren',
			'no_ads'		=> '    Keine Werbung',
			''				=> 'Banner einfügen:'
		);
		foreach ($other_options as $key => $value) {
?>
var opt = document.createElement("option");
opt.value='<?php echo wp_specialchars($key); ?>';
opt.innerHTML='<?php echo $value; ?>';
ed_contaxe.appendChild(opt);
<?php 
		}

		if (sizeof($options['banners']) != 0) {
			foreach ($options['banners'] as $banner) {
?>
var opt = document.createElement("option");
opt.value='<?php echo wp_specialchars($banner['name']); ?>';
opt.innerHTML='    <?php echo $banner['name']; ?>';
ed_contaxe.appendChild(opt);
<?php
			}
		}
?>
document.getElementById("ed_toolbar").insertBefore(ed_contaxe, document.getElementById("ed_spell"));
			    
/* Below is a kludge for IE, which causes it to re-read the state of onChange etc. set above. */
if (navigator.appName == 'Microsoft Internet Explorer') {
	document.getElementById("ed_toolbar").innerHTML=document.getElementById("ed_toolbar").innerHTML; 
}
				
function add_contaxe(element) {
	if (element.value == '') return;
	else if (element.value == 'no_ads')		{ contaxe_code = '<!--wpcontaxe_no_ads-->'; }
	else if (element.value == 'no_hl')		{ contaxe_code = '<!--wpcontaxe_no_hl-->'; }
	else if (element.value == 'no_banners')	{ contaxe_code = '<!--wpcontaxe_no_banners-->'; }
	else									{ contaxe_code = '<!--wpcontaxe#' + element.value + '-->';}

	contentField = document.getElementById("content");
	if (document.selection && !window.opera) {
		// IE compatibility
		contentField.value += contaxe_code;
	} else {
		if (contentField.selectionStart || contentField.selectionStart == '0') {
			var startPos = contentField.selectionStart;
			var endPos = contentField.selectionEnd;
			contentField.value = contentField.value.substring(0, startPos) + contaxe_code + contentField.value.substring(endPos, contentField.value.length);
		}
		else {
			contentField.value += contaxe_code;
		}
	}
	element.selectedIndex=0;
}
// -->
</script>
<?php
	}

	function registerWidget() {
		if (!function_exists('wp_register_sidebar_widget')) return;
		$class	= array('classname' => 'widget_wpcontaxe');
		$dims	= array('width' => 350, 'height' => 170);
		for ($i = 1; $i <= $this->numWidgets; $i++) {
			$id		= 'widget_wpcontaxe-' . $i;
			$name	= sprintf(__('Contaxe-Anzeige %d'), $i);
			wp_register_sidebar_widget($id, $name, array(&$this, 'callback_widget'), $class, $i);
			wp_register_widget_control($id, $name, array(&$this, 'callback_widget_control'), $dims, $i);
		}
	}

	function placeAds($type, $content) {
		global $WPCONTAXE_POSITIONS, $wp_query;
		$options	= $this->getAdminOptions();
		$top_center = $top_left = $top_right = $middle_center = $middle_left = $middle_right = $bottom_center = '';
		foreach ($options['positions'] as $id => $pos) {
			$position = $WPCONTAXE_POSITIONS[$id];
			if ($position['type'] != $type) continue;
			if ($type == 'multiple') {
				if ($pos['position'] > 0) {
					if ($pos['position'] != $wp_query->current_post + 1) continue;
				}
				if ($pos['position'] < 0) {
					if ($wp_query->post_count + $pos['position'] != $wp_query->current_post) continue;
				}
			}
			if (($code = $this->getBannerURL($pos['banner'])) == '') continue;
			$code = $this->getAdCode($code);
			switch (true) {
				case $position['valign'] == 'top' && $position['align'] == 'center':
					$top_center	= '<p style="text-align: center;">'				. $code . '</p>'; break;
				case $position['valign'] == 'top' && $position['align'] == 'left':
					$top_left	= '<p style="float: left; margin: 4px;">'		. $code . '</p>'; break;
				case $position['valign'] == 'top' && $position['align'] == 'right':
					$top_right	= '<p style="float: right; margin: 4px;">'		. $code . '</p>'; break;
				case $position['valign'] == 'middle' && $position['align'] == 'center':
					$middle_center	= '<p style="text-align: center;">'			. $code . '</p>'; break;
				case $position['valign'] == 'middle' && $position['align'] == 'left':
					$middle_left	= '<p style="float: left; margin: 4px;">'	. $code . '</p>'; break;
				case $position['valign'] == 'middle' && $position['align'] == 'right':
					$middle_right	= '<p style="float: right; margin: 4px;">'	. $code . '</p>'; break;
				case $position['valign'] == 'bottom' && $position['align'] == 'center':
					$bottom_center	= '<p style="text-align: center;">'			. $code . '</p>'; break;
				default:
					break;
			}
		}
		$middle = $middle_center . $middle_left . $middle_right;
		$content = $this->injectIntoMiddle($content, $middle);
		return $top_center . $top_left . $top_right . $content . $bottom_center;
	}

	function callback_widget_text($content) {
		return $this->callback_content($content, FALSE);
	}

	function callback_content($content, $real = TRUE) {
		$options	= $this->getAdminOptions();
		$type		= '';
		if (strpos($content, '<!--wpcontaxe_no_ads-->') !== FALSE) {
			$content = str_replace('<!--wpcontaxe_no_ads-->', '<!--wpcontaxe: Werbung komplett deaktiviert-->', $content);
			return '<div class="chlforbidden">' . $content . '</div>';
		}
		while (preg_match('/<!--wpcontaxe#(.*?)-->/', $content, $match) == 1) {
			$name = $match[1];
			$code = '';
			foreach ($options['banners'] as $banner) {
				if (wp_specialchars($banner['name']) == $name) {
					$code = $this->getAdCode($this->getBannerURL($banner['id']));
					break;
				}
			}
			$content = str_replace('<!--wpcontaxe#' . $name . '-->', $code, $content);
		}
		if ($options['highlighter_enabled']) {
			if (strpos($content, '<!--wpcontaxe_no_hl-->') !== FALSE || ($real && !is_single() && !is_page() && !$this->checkHighlighterRules(false))) {
				$content = str_replace('<!--wpcontaxe_no_hl-->', '<!--wpcontaxe: Highlighter deaktiviert-->', $content);
				$content = '<div class="chlforbidden">' . $content . '</div>';
			}
		}
		if (strpos($content, '<!--wpcontaxe_no_banners-->') !== FALSE) {
			return str_replace('<!--wpcontaxe_no_banners-->', '<!--wpcontaxe: Keine Banner in diesem Beitrag-->', $content);
		}
		if (!$real) return $content;
		switch (true) {
			case is_single():
				return $this->placeAds('single',	$content);
			case is_page():
				return $this->placeAds('page',		$content);
			default:
				return $this->placeAds('multiple',	$content);
				break;
		}
	}

	function callback_wp_footer() {
		$this->addHighlighter();
		$this->addIAS();
		$this->addEditorButton();
	}

	function callback_widget($args, $number) {
		extract($args);
		$options	= $this->getAdminOptions();
		if (($url = $this->getBannerURL($options['widgets'][$number]['banner'])) == '') return;
?>
			<?php echo $before_widget; ?>
				<?php echo $before_title . wp_specialchars($options['widgets'][$number]['title']) . $after_title; ?>
				<p style="text-align: center; margin-top: 10px;"><?php echo $this->getAdCode($url); ?></p>
			<?php echo $after_widget; ?>
<?php
	}

	function callback_widget_control($number) {
		$options	= $this->getAdminOptions();
		if (isset($_POST['wpcontaxe-submit-' . $number])) {
			$options['widgets'][$number]['title']	= $_POST['wpcontaxe-title-' . $number];
			$options['widgets'][$number]['banner']	= $_POST['wpcontaxe-banner-' . $number];
			update_option($this->adminOptionsName, $options);
			$this->options = $options;
		}
?>
<p><label for="wpcontaxe-title-<?php echo $number; ?>"><?php _e('Title:'); ?></label></p> <input style="width: 350px;" id="wpcontaxe-title-<?php echo $number; ?>" name="wpcontaxe-title-<?php echo $number; ?>" type="text" value="<?php echo attribute_escape($options['widgets'][$number]['title']); ?>" />

<p><label for="wpcontaxe-banner-<?php echo $number; ?>"><?php _e('Banner:'); ?></label></p>
<select style="width: 350px;" id="wpcontaxe-banner-<?php echo $number; ?>" name="wpcontaxe-banner-<?php echo $number; ?>" class="wpcontaxe_select">
<?php
		foreach ($options['banners'] as $banner) {
			echo '<option value="' . $banner['id'] . '"' . ( $banner['id'] == $options['widgets'][$number]['banner'] ? ' selected="selected"' : '' ) . '>' . $banner['id']  . ' - ' . attribute_escape($banner['name']) . (!$banner['enabled'] ? ' (deaktiviert)' : '') . "</option>\n";
		}
?>
</select>
<input type="hidden" id="wpcontaxe-submit-<?php echo $number; ?>" name="wpcontaxe-submit-<?php echo $number; ?>" value="1" />
<?php
	}

	/*
	 * parts of the following function are borrowed from adman 
	 * http://wp.uberdose.com/2006/11/05/adman/
	 * Copyright (C) 2007 uberdose.com (adman AT uberdose DOT com)
	 * released under GPLv2
	 */
	function get_occurrences($content, $what) {
		$result = array();
		$pos = 0;
		while($pos !== false) {
			$pos = strpos($content, $what, $pos);
			if ($pos === false) {
				return $result;
			}
			$pos += strlen($what) + 1;
			array_push($result, $pos);
			if ($pos >= strlen($content)) {
				return $result;
			}
		}
		return $result;
	}

	/*
	 * parts of the following function are borrowed from adman 
	 * http://wp.uberdose.com/2006/11/05/adman/
	 * Copyright (C) 2007 uberdose.com (adman AT uberdose DOT com)
	 * released under GPLv2
	 */
	function injectIntoMiddle($content, $code) {
		if ($code == '') return $content;
		$middle = intval(strlen($content) / 2);
		$positions = $this->get_occurrences($content, '</p>');
		$positions = array_merge($positions, $this->get_occurrences($content, '</div>'));
		$positions = array_merge($positions, $this->get_occurrences($content, '</ul>'));
		$positions = array_merge($positions, $this->get_occurrences($content, '</ol>'));
		$positions = array_merge($positions, $this->get_occurrences($content, '</pre>'));
		$deviations = array();
		foreach ($positions as $pos) {
			$diff = abs($pos - $middle);
			$deviations[$diff] = $pos;
		}
		ksort($deviations);
		$final = array_shift($deviations);
		if ($final > 0) $content = substr($content, 0, $final - 1) . $code . substr($content, $final - 1);
		return $content;
	}


	function setCookie() {
		if (is_admin()) return;
		$cntvisits	= isset($_COOKIE['wpcontaxe_cntvisits']) ? $_COOKIE['wpcontaxe_cntvisits'] + 1	: 1;
		$lastvisit	= isset($_COOKIE['wpcontaxe_lastvisit']) ? $_COOKIE['wpcontaxe_lastvisit']		: 0;
		$time		= time();
		$url = parse_url(get_option('home'));
		setcookie('wpcontaxe_cntvisits', $cntvisits,	$time+60*60*24*365, $url['path'] . '/');
		setcookie('wpcontaxe_lastvisit', $time,			$time+60*60*24*365, $url['path'] . '/');
		$this->cntVisits = $cntvisits;
		$this->lastVisit = $lastvisit;
	}
}

function wpcontaxe_banner($id) {
	$GLOBALS['wpcontaxe']->showBanner($id);
}

}

$wpcontaxe = new WPContaxe();

register_activation_hook(__FILE__, array(&$wpcontaxe, 'activatePlugin'));

add_action('init',			array(&$wpcontaxe, 'registerWidget'));
add_action('admin_menu',	array(&$wpcontaxe, 'registerAdminMenu'));
add_action('admin_head',	array(&$wpcontaxe, 'printAdminCSS'));
add_action('admin_footer',	array(&$wpcontaxe, 'printAdminJS'));
add_action('plugins_loaded',array(&$wpcontaxe, 'setCookie'));

add_action('wp_footer',		array(&$wpcontaxe, 'callback_wp_footer'));
add_action('admin_footer',	array(&$wpcontaxe, 'addEditorButton'));

add_filter('the_content',	array(&$wpcontaxe, 'callback_content'), 100);
add_filter('the_excerpt',	array(&$wpcontaxe, 'callback_content'), 100);
add_filter('widget_text',	array(&$wpcontaxe, 'callback_widget_text'), 1);

?>
